



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>协同过滤的R语言实现及改进</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">协同过滤的R语言实现及改进</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 16:46:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>欢迎大家前往<a href="https://cloud.tencent.com/developer/?fromSource=waitui" rel="external nofollow noreferrer">腾讯云+社区</a>，获取更多腾讯海量技术实践干货哦~</strong></p>
<blockquote><p>协同过滤算法是推荐系统最常用的算法之一，本文将介绍一种方法来使它可以在大型数据集上快速训练。</p></blockquote>
<p>协同过滤算法（CF）是构建推荐系统时最常用的技术之一。它可以基于收集到的其他用户的偏好信息（协同）来自动地预测当前用户的兴趣点。协同过滤算法主要分为两种：基于记忆（memory-based）的协同过滤算法和基于模型（model-based）的协同过滤算法。一般来说，将两者融合可以获得预测准确度上的提升。</p>
<p>在本文中，我们将关注基于记忆的协同过滤算法并详细讨论其推导和集成的细节。我们将展示我们最近在改进经典协同过滤算法上的一些工作，使其可以在大规模数据集上实施并达到缩短训练时间的效果。我们的算法是用R语言实现的，但是它也可以被移植到其他语言上。</p>
<p>基于记忆的协同算法又可以分为下面两种：</p>
<ul><li>基于用户的协同过滤：如果想要预测用户U对物品I的评价，可以借助其他和U相似的用户的评价来进行预测。这么做的原因是我们认为相同品味的用户会对同一事物做出相似的评价。</li>
<li>基于物品的协同过滤：如果想要预测用户U对物品I的评价，可以借助该用户对和物品I相似的物品的评价进行预测。这么做的原因是我们认为同一用户对相似事物做出的评价应当是接近的。</li></ul>
<p>下面让我们从一个例子出发来观察基于用户的协同过滤是如何实现的。下面给出了计算评价r<sub>u,i</sub>的公式，r<sub>u,i</sub>&nbsp;即用户u对物品i的评分。我们把和用户u相似的用户（用户之间的相似度信息通过一个矩阵维护，sim为相似度计算函数）的评价汇总在一起，从公式可以看出，用户间的相似度越大，其中一个用户对另一个用户评价的预测结果影响程度就越大。w为计算最终评分所需的归一化权重因子。</p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/hxs09kjrcn.png?imageView2/0/w/1620"></div>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/8zqjxbx4oe.png?imageView2/0/w/1620"></div>
<p>为了验证当前推荐系统的性能，我们需要在测试集上进行预测。为了更高的效率，计算会借助矩阵乘法完成，而不是通过循环的方式完成。下面的图片展示了矩阵计算的过程：</p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/xhyfomuh4.png?imageView2/0/w/1620"></div>
<div>从左到右依次为 用户对物品的评分矩阵 用户相似度矩阵 预测结果矩阵</div>
<p>上图展示了预测用户U<sub>2</sub>对物品I<sub>3</sub>评分时的计算过程。为了计算预测结果，我们需要知道其他用户对I<sub>3</sub>的评分（第一个矩阵中蓝色高亮的一行）以及其他用户与U<sub>2</sub>的相似度（第二个矩阵中蓝色高亮的一列；注意这里我通过设置相似度矩阵对角线的元素为零来避免数据泄露）。到此，我们可以写出用户U<sub>2</sub>对物品I<sub>3</sub>评分的计算公式：</p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/ztqc5e0xly.png?imageView2/0/w/1620"></div>
<p>计算结果将被存储在第三个矩阵的蓝色单元当中。不过这里还没有进行归一化，为了得到最终的预测结果，我们还需要计算归一化因子w，计算公式已经在上面给出。</p>
<p>基于记忆的协同过滤的主要优点与它的可扩展性和性能密不可分。举例来说，如果这里有500,000个用户，那么我们需要计算所有用户对之间的相似度（最坏的情况需要计算1200亿个值）。显然这需要大量的内存和处理时间，下面我们将尝试用R语言（当然你也可以使用别的编程语言 : ) ）对协同过滤算法进行一些改进从而解决这一问题。</p>
<p>我们将用R推荐系统中最常用的包之一——recommenderlab与我们的实现进行比较。这个比较是在4核i7，16G内存的小型电脑上完成的，使用的数据集是 <a href="https://grouplens.org/datasets/movielens/" rel="external nofollow noreferrer">MovieLens 100k, MovieLens 1m,&nbsp;MovieLens 10m</a>。后面，你会看到我们的集成具有两大优势：</p>
<ol><li>它的速度有显著的提升。</li>
<li>可以支持在庞大的数据集上构建推荐系统，当 recommenderlab 报出内存溢出的错误时，我们的实现仍然可以正常工作。</li></ol>
<h2>执行效率的提升</h2>
<p>评分矩阵通常是一个庞大（有大量的用户和物品）的稀疏（每个用户往往只对少量的物品打分）矩阵。在R语言中，我们可以通过专门的数据结构来存储稀疏矩阵，缺失值不会被重复存储在内存当中。一般来说，有超过90%的值是缺失的，所以这种做法可以节省下大量的内存。我们的实现以及recommenderlab中都采用了矩阵的稀疏表示。</p>
<p>我们实现的基于用户的协同过滤主要包含以下步骤（基于物品的协同过滤也是如此）：</p>
<ol><li>导入评分矩阵</li>
<li>开发者决定是否对用户评分进行标准化。这一步通常会提高准确率。这是因为标准化可以移除用户评分的偏置，举例来说就是有些用户总是会打高分或者总是打低分。</li>
<li>计算用户之间的相似度。</li>
<li>使用KNN算法。（只保留k个最相似的用户，即在用户的评分预测计算中，相似度矩阵每列只保存最高的k个值）k值需要开发者手动指定。</li>
<li>计算预测值并进行反归一化得到最终的预测评分。</li></ol>
<p>recommenderlab也使用了与上面相同的过程。但是我们在这些过程中引入了一些改进从而显著地提升了算法执行效率。其中主要的两个优化如下：</p>
<ol><li>对大型稀疏矩阵的相似性计算进行了优化。具体方法可以参考<a href="https://dzone.com/articles/recommender-systems-matrix-operations-for-fast-cal" rel="external nofollow noreferrer">Recommender Systems: Matrix Operations for Fast Calculation of Similarities</a>。</li>
<li>相似度矩阵的k近邻算法不是通过循环完成的，我们采用了更优的实现。首先，我们对相似度矩阵进行了分组（列拆分），然后在每组当中通过函数找到最高的k个值。这个函数已经在R 'data.table'包中被实现。依此，我们通过每组的信息得到了相似度矩阵中每列最大的k个值。</li></ol>
<h2>验证</h2>
<p>我们通过以下步骤来讲我们的实现与recommenderlab进行比较：</p>
<ul><li><strong>10折交叉验证</strong>。每次训练使用90%的数据来创建模型、计算相似度，10%的数据用来测试。任一用户和物品都被划分到了训练集或者测试集当中。</li>
<li>中心归一化（<strong>Center Normalization</strong>），用户评分的平均值将从他的实际评分中扣除。</li>
<li>用<strong>余弦距离</strong>来计算相似度。</li>
<li><strong>k</strong>：选取的近邻样本数为100，300以及样本总值。</li>
<li><strong>rmse</strong>：算法的误差（root-mean-square error，均方根误差）</li>
<li><strong>执行时间</strong> (exec time) ：算法的执行时间，以秒为单位。</li></ul>
<h3>在100k MovieLens 数据集上的比较</h3>
<p>该数据集包括943个用户和1682个电影（物品），100,000个评分。</p>
<p><strong>基于用户的协同过滤</strong></p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/kwm3fkl0vv.png?imageView2/0/w/1620"></div>
<p><strong>基于物品的协同过滤</strong></p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/ticboth738.png?imageView2/0/w/1620"></div>
<h3>在1M MovieLens 数据集上的比较</h3>
<p>该数据集包括6040个用户和3706个电影（物品），100,000个评分。</p>
<p><strong>基于用户的协同过滤</strong></p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/ycygwralqs.png?imageView2/0/w/1620"></div>
<p><strong>基于物品的协同过滤</strong></p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/llhga164kx.png?imageView2/0/w/1620"></div>
<p>可以看到我们的实现在运行速度上更快，精准度也更高（达到了更低的rmse）。其中我们最关注的方面——速度得到了显著的提升。</p>
<p>然而，速度只是经典实现中问题的一个方面。我们在上面提到过，协同过滤的另一个问题是空间占用，即当矩阵过于庞大时我们会面临内存不足的问题。在下一节中，我们将提出一个可行的方案来使传统的协同过滤算法可以被应用在庞大的数据集上。</p>
<h3>在庞大的数据集上构建推荐算法</h3>
<p>在下面的测试中，我们使用MovieLens 10m的数据集。但是正如上面提到的，我们测试的机器只有16GB的内存并且使用了十折的交叉验证。'recommenderlab'的实现在建立用户相似度矩阵的过程中就因为内存不足而退出了。</p>
<p>在我们的实现当中，我们通过对矩阵进行切分解决了这一问题。即我们不是一次性计算所有的预测值，而是一块一块完成的。下面给出基于用户的协同过滤的实现过程（基于物品的协同过滤同理）：</p>
<ol><li>取出用户评分矩阵的前N行。在下图图示中，我们提取了I1:I4部分的切片。</li>
<li>取出M个用户并计算他们与其他用户的相似度。在下图图示中，我们提取了U1:U2部分的切片。</li>
<li>根据公式计算第一步得到的矩阵和第二步得到的矩阵的乘积。结果为MxN的矩阵，矩阵的元素为归一化之前的预测结果。在图示中，计算结果为用户U1:U2对物品I1:I4的评分。</li>
<li>重复以上三步计算不同的MxN单元只到结果矩阵被填满。</li></ol>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/l7u4y4q6oe.png?imageView2/0/w/1620"></div>
<h3>在10M MovieLens 数据集上的结果</h3>
<p>该数据集包括69,878个用户和10,677个电影（物品），10,000,054个评分。我们通过以下步骤来检验我们的算法：</p>
<ul><li><strong>10折交叉验证</strong>。</li>
<li>中心归一化（<strong>Center Normalization</strong>）。</li>
<li>用<strong>余弦距离</strong>来计算相似度。</li>
<li><strong>k</strong>：选取的近邻样本数为100，1000。</li>
<li><strong>Chunk size</strong>：在算法当中每次取出的块的行列大小。具体的取值取决于你的硬件条件。</li></ul>
<p>比较的结果可以从下面的表格找到，包含：</p>
<ul><li><strong>rmse</strong>：算法的误差（root-mean-square error）</li>
<li><strong>执行时间</strong>：算法的执行时间，以分钟为单位。</li>
<li><strong>num predictions</strong>：协同过滤能够预测的结果数。通常来说，协同过滤不是一定能够得到预测结果的（比方说与之相似的用户也都还没有给该商品打分）</li></ul>
<p><strong>基于物品的协同过滤</strong></p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/ujhcnierwd.png?imageView2/0/w/1620"></div>
<p><strong>基于用户的协同过滤</strong></p>
<div><img referrerpolicy="no-referrer"src="https://ask.qcloudimg.com/http-save/410635/t8jkjas7aw.png?imageView2/0/w/1620"></div>
<p>正如上图展示的结果所示，我们实现的算法完满地完成了任务。现在我们可以在16Gb内存配置的机器上构建推荐系统了。基于用户和基于物品的协同过滤分别耗费了10分钟和200分钟的时间，基于用户的协同过滤花费了更多的时间是因为数据集中有了更多的用户，这要求我们计算更多的相似度。</p>
<p>通过现在的实现，当我们需要为一个或者多个用户提供实时的推荐时，相似度的计算以及结果的预测将迅速很多，因为我们可以只选取少部分用户进行操作。在MovieLens 10m的数据集上，基于用户的协同过滤只需要一秒就可以对一个用户或者多个用户生成预测，但是基于物品的协同过滤则需要30s左右，这是因为我们需要更多的时间来计算相似度矩阵。这里还可以通过将相似度矩阵存储为模型，不再进行即时的训练从而达到线上预测效果的加速。这个算法实现的一个显著优点就是可扩展性，由于我们将原数据集切分为了不同块进行计算，所以可以进一步实现并行化。我们接下来的工作之一就是在分布式框架上实现并测试这一方法。</p>
<h2>总结</h2>
<p>在本文中，我们提出了一种新的方法来改进基于记忆的传统协同过滤实现。本文的代码可以从<a href="https://github.com/smartcat-labs/collaboratory" rel="external nofollow noreferrer">Github</a>上获取。</p>
<blockquote><p><strong>问答</strong></p>
<div>
<div>
<div>
<div>
<div>
<p><a href="https://cloud.tencent.com/developer/ask/35972?fromSource=waitui" rel="external nofollow noreferrer">如何从源安装R语言包？</a></p>
</div>
</div>
</div>
</div>
</div>
<p><strong>相关阅读</strong></p>
<p><a href="https://cloud.tencent.com/developer/article/1058304?fromSource=waitui" rel="external nofollow noreferrer">用R解析Mahout用户推荐协同过滤算法(UserCF)</a></p>
<p><a href="https://cloud.tencent.com/developer/article/1092064?fromSource=waitui" rel="external nofollow noreferrer">近邻推荐之基于用户的协同过滤</a></p>
<p><a href="https://cloud.tencent.com/developer/article/1086282?fromSource=waitui" rel="external nofollow noreferrer">协同过滤原理及Python实现</a></p></blockquote>
<p><strong>此文已由作者授权腾讯云+社区发布，原文链接：https://cloud.tencent.com/developer/article/1133912?fromSource=waitui</strong><br><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1112679/201805/1112679-20180515153644255-433320237.jpg"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495g7yeq.html">SQL联合主键 查重</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdzr1j9.html">java 枚举类型 构造函数及用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mrnjp9.html">java中string内存的相关知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/390044o9.html">汇编学习（一）&amp;mdash&semi;&amp;mdash&semi;win7 64位调出debug</a>
		</li>
						<li><a href="https://www.batexi.com/a/390gd3n8.html">JQ选择器逐一测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdnj2j9.html">Xcode6与Xcode5中沙盒的变动以及偏好设置目录的变动</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xoxng9.html">PHP的基本语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv3ekoq.html">命令行添加用户的&OpenCurlyDoubleQuote;作为服务登录&rdquo;权利（添加Windows用户的时候，门道不是一般的多）good</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m3z5gq.html">&lbrack;AC自动机&rsqb;HDOJ3695 Computer Virus on Planet Pandora</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwx1xq.html">&lbrack;C&num;&rsqb;获取最近在Windows上所使用的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrl6lq.html">《think in python》学习-4</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojkvwpq.html">拍照图片滤镜sample</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj55338.html">POJ3723最小生成树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey731x9.html">python网络编程基础知识整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjp0r38.html">JAVA基础复习与总结&amp;lt&semi;十&amp;gt&semi; Ruannable和Callable</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyonnq.html">css3动画的简单学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emye2z9.html">pygame系列&lowbar;font游戏字体&lowbar;源码下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vr362q.html">activiti工作流之Eclipse的Eclipse BPMN 2&period;0 Designer无法安装或者&lpar;安装后无法重复打开&ast;&period;bpmn&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kpgk3q.html">js设置、修改、获取、删除 cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5w7dj9.html">js判断客户浏览器类型，版本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rgrkjm8.html">Roman to Integer&lpar;将罗马数字转成整数&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgdx39.html">OSGI介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zv6xe9.html">C语言关键字register、extern、static、一些总结，及项目中使用的心得</a>
			</li>
						<li><a href="https://www.batexi.com/a/950kyrv8.html">access窗口标签居中</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpg4nr9.html">SQL SERVER 锁资源问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/950kvxv8.html">SignUtil</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zon2o3q.html">window&period;open open new window&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y21vg8.html">大型三甲医院信息管理系统源码 His系统功能齐全 完整可用</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mxx0o8.html">Java单例模式&lpar;Singleton&rpar;以及实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k66x59.html">Visual Studio 和 c&num; 正则表达式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
